/**~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: IInterfazCliente.java,v 1.1 2006/11/09 03:11:31 f-vela Exp $ 
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Todos los derechos reservados 2005 
 *
 * Proyecto Cupi2 
 * Ejercicio: n12_messengerAmigos 
 * Autor: Mario Snchez - 2/05/2006 
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ 
 */

package uniandes.cupi2.messengerAmigos.interfazCliente;
 
import java.util.Collection;

import uniandes.cupi2.messengerAmigos.cliente.Conversacion;
 
/**
 * Esta interfaz define los mtodos que ofrece la interfaz del cliente del messenger y que le interesan a la clase ClienteAmigos
 */
public interface IInterfazCliente
{
    /**
     * Si se haba solicitado que se terminara el programa, se cierra la ventana y la aplicacin. <br>
     * <b>pre: </b>El cliente est desconectado del servidor y no hay conversaciones en curso.
     */
    void terminarAplicacion( );

    /**
     * Actualiza la lista de amigos mostrada
     * @param amigos Una coleccin con los amigos (Usuario) del usuario - amigos != null
     */
    void actualizarAmigos( Collection amigos );

    /**
     * Actualiza la interfaz segn el estado de la conexin: <br>
     * Se actualiza el ttulo de la ventana y se activan o desactivan opciones de la barra de men
     */
    void actualizarEstadoInterfaz( );

    /**
     * Crea una nueva ventana para una conversacin
     * @param conv La conversacin asociada a la nueva ventana - conv != null
     */
    void crearVentanaConversacion( Conversacion conv );
}