/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: PanelMensajesConversacion.java,v 1.1 2006/11/09 03:11:31 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 24/04/2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

package uniandes.cupi2.messengerAmigos.interfazCliente;

import java.awt.BorderLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

/**
 * Este es el panel donde se muestran los mensajes recibidos en una conversacin
 */
public class PanelMensajesConversacion extends JPanel
{

    // -----------------------------------------------------------------
    // Atributos de la Interfaz
    // -----------------------------------------------------------------

    /**
     * Es el campo de texto donde se muestran los mensajes de la conversacin
     */
    private JTextArea txtMensajes;

    // -----------------------------------------------------------------
    // Constructores
    // -----------------------------------------------------------------

    /**
     * Construye el panel e inicializa sus componentes
     */
    public PanelMensajesConversacion( )
    {
        setLayout( new BorderLayout( ) );

        txtMensajes = new JTextArea( );
        txtMensajes.setWrapStyleWord( true );
        txtMensajes.setLineWrap( true );
        txtMensajes.setEditable( false );

        JScrollPane scroll = new JScrollPane( );
        scroll.getViewport( ).add( txtMensajes );

        add( scroll );
    }

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Agrega un mensaje al final del rea de mensajes
     * @param mensaje El mensaje que se va a mostrar - mensaje != null
     */
    public void agregarMensaje( String mensaje )
    {
        txtMensajes.append( mensaje + "\n" );
        txtMensajes.setCaretPosition( txtMensajes.getText( ).length( ) );
    }
}
