/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: VentanaConversacion.java,v 1.1 2006/11/09 03:11:30 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 21/04/2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

package uniandes.cupi2.messengerAmigos.interfazCliente;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


import uniandes.cupi2.messengerAmigos.cliente.Conversacion;
import uniandes.cupi2.messengerAmigos.verificador.IVerificadorMensajes;

/**
 * Esta es la ventana en la cual se envan y se muestran los mensajes de una conversacin
 */
@SuppressWarnings("serial")
public class VentanaConversacion extends JFrame implements IVentanaConversacion, IVerificadorMensajes
{
    // -----------------------------------------------------------------
    // Atributos
    // -----------------------------------------------------------------

    /**
     * Es la conversacin asociada a esta ventana
     */
    private Conversacion conversacion;

    // -----------------------------------------------------------------
    // Atributos de la Interfaz
    // -----------------------------------------------------------------

    /**
     * Es el panel donde se muestran los mensajes de la conversacin
     */
    private PanelMensajesConversacion panelMensajes;

    /**
     * Es el panel desde donde se envan los mensajes de la conversacin
     */
    private PanelEnviarMensajes panelEnviarMensajes;

    /**
     * Barra del menu y opcin activa en cada uni
     */
    
    private JMenuBar mb;
    
    private int activeOption1 = 0;
    
   	private int i;
	JMenu menuAutomata = new JMenu("Revisar");
		
	JCheckBoxMenuItem items [] 	;

    
    // -----------------------------------------------------------------
    // Constructores
    // -----------------------------------------------------------------

    /**
     * Inicializa la ventana
     * @param conv Es la conversacin asociada a la ventana - conv != null
     */
    public VentanaConversacion( Conversacion conv )
    {
        conversacion = conv;
        conv.cambiarVentanaConversacion( this );
        setTitle( "Hablando con " + conv.darNombreAmigo( ) );
        setDefaultCloseOperation( JFrame.DISPOSE_ON_CLOSE );

        setLayout( new GridBagLayout( ) );
        GridBagConstraints gbc = new GridBagConstraints( 0, 0, 1, 1, 1, 0.7, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets( 5, 5, 5, 5 ), 0, 0 );
        panelMensajes = new PanelMensajesConversacion( );
        getContentPane( ).add( panelMensajes, gbc );

        gbc.gridy = 1;
        gbc.weighty = 0.3;
        panelEnviarMensajes = new PanelEnviarMensajes( this );
        getContentPane( ).add( panelEnviarMensajes, gbc );

        items = new JCheckBoxMenuItem[names.length];
    
        for (int i = 0; i < items.length; i++) {
        	items[i] = new JCheckBoxMenuItem(names[i]);
    		menuAutomata.add(items[i]);	
    		items[i].addActionListener(new myAction(i));
    	 }
        
        mb = new JMenuBar();
  		
        setJMenuBar(mb);
		mb.add(menuAutomata);
        
		items[0].setSelected(true);
  		activeOption1 = 0;
  		
        setSize( 250, 400 );
    }

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Muestra un mensaje en la ventana
     * @param mensaje El mensaje que debe ser mostrado - mensaje != null
     */
    public void publicarMensaje( String mensaje )
    {
        panelMensajes.agregarMensaje( mensaje );
    }

    /**
     * Enva un mensaje al amigo y lo muestra
     * @param mensaje El mensaje que debe ser enviado y mostrado - mensaje != null
     */
    public void enviarMensaje( String mensaje )
    {
        conversacion.enviarMensaje( mensaje );
    }

    /**
     * Cierra la conversacin y cierra la ventana <br>
     * Si la ventana es cerrada por el usuario, entonces se cierra la conversacin asociada tambin.
     */
    public void dispose( )
    {
        if( !conversacion.conversacionTerminada( ) )
            conversacion.terminar( );

        else
            super.dispose( );
    }

    
    
  /**
  *  PAra cambair la seleccion del revisor
  **/
   
    public void changeCheck(int item) {
    	items[activeOption1].setSelected(false);  			
		activeOption1 = item;
		items[activeOption1].setSelected(true);
	}
    
    /**
     *  Clase internma para el action listenter 
     **/
   
    class myAction implements ActionListener {
      private int index;
      myAction(int i) {
    	index = i;  
      }
      public void actionPerformed(ActionEvent e) {
			changeCheck(index);
			conversacion.cambiarCheck(index);
	  }
    }
  }
