package uniandes.cupi2.messengerAmigos.verificador;



/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: CheckerTranslator.java,v 1.0 2009/13/03  stakahas  $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos-TEOLEN
 * Autor: Silvia Takahashi
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
public class CheckerTranslator implements ICheckerTranslator {

	private int chType = Copy;
	
	private IMessageMng coderChecker = null;
	private IMessageMng decoder = null;
	
	private String inputString =  "";
	private Object result = "";
	
	public CheckerTranslator() {
		chType = Copy;
		
		coderChecker = null;
		decoder = null;
		
		inputString =  "";
		result = "";
	}
	
	public CheckerTranslator(IMessageMng outCheck) {
		chType = CheckOnly;
		coderChecker = outCheck;
		
		decoder = null;
		
		 inputString =  "";
		 result = "";
	}
	
	public CheckerTranslator(IMessageMng in, int CheckType) {
		decoder = null;
		inputString =  "";
		result = "";
		chType = CheckType;
		coderChecker = in;
	}
	
	public CheckerTranslator(IMessageMng sent, IMessageMng rec) {
		
		inputString =  "";
		result = "";
		
		chType = CodeDecode;
		coderChecker = sent;
		decoder = rec;
	}
	
	public void setInput(String m) {
		inputString = m;
		if (coderChecker != null)
			coderChecker.setInput(m);
		if (decoder != null)
			decoder.setInput(m);
				
	}
	
	public Object checkAndCode() throws Exception, Error, Throwable {
		
		Object o;
		result = inputString;
		
		if (chType != Copy) {
		    	o = coderChecker.input();
		    	if (chType!= CheckOnly) {
		    		result = o;
		    	}
		}
		
		return result;    		
	} 
		  
		
	
	public Object deCode() throws Exception, Error, Throwable {
		
		Object o;
		result = inputString;
		
		 if (chType == CodeDecode) {
		    	o = decoder.input();
		    	result = o;
		    	System.out.println(o);
		 }
		    
		 return result;
	}
	
	public  boolean hayDeco(){
		return chType==CodeDecode;
	}
	
	
}
