package uniandes.cupi2.messengerAmigos.verificador;

import uniandes.cupi2.messengerAmigos.verificador.gold.*;
import uniandes.cupi2.messengerAmigos.verificador.mundoAutomata.*;
import uniandes.cupi2.messengerAmigos.verificador.parsers.*;

public class VerificadorMensajes implements ICheckerTranslator, IVerificadorMensajes {
 


private CheckerTranslator checks [] = {

    new CheckerTranslator(),
		new CheckerTranslator(new FraseAceptable(0)),
		new CheckerTranslator(new FraseAceptable(1),new FraseAceptable(-1)),
		new CheckerTranslator(new Parser(),CheckOnly),
		new CheckerTranslator(new SimpleParser(System.in),CheckOnly),
		new CheckerTranslator(new ParserCAML(System.in),Code),
		
		/* extensiones GOLD */
		new CheckerTranslator(new GoldAdaptor(DivPorN_GOLD.createTransducer(3)),Code),
		new CheckerTranslator(new GoldAdaptor(Taller3_201120_Punto1.createTransducer()),new GoldAdaptor(Taller3_201120_Punto2.createTransducer())),
		new CheckerTranslator(new GoldAdaptor(Taller3_201120_Punto3.createTransducer()),new GoldAdaptor(Taller3_201120_Punto4.createTransducer())),

		/* extensiones actualmente asociadas a el verificador que no revisa ni traduce */
		/*  Al agregarlos ac deben agregar los nombres en IVerificadorMensajes */
		new CheckerTranslator(),
		new CheckerTranslator(),

};

  
private int checker = 7;

public	 VerificadorMensajes () {
}




public void setCheck(int c) {
	checker = c;	
}
 
public MensajeConRespuesta traducir(String m ) {
	MensajeConRespuesta resp = new MensajeConRespuesta("ERROR!!", false);
    String res = new String();
	
	checks[checker].setInput(m);
	try {
		res = checks[checker].checkAndCode().toString();
		resp = new MensajeConRespuesta(res,true);
	}
	catch(ParseException pex) {
		resp = new MensajeConRespuesta(pex.getMessage(),false);
	}
	catch (Throwable other) {
		resp = new MensajeConRespuesta(other.getMessage(),false);
	}
	return resp;
}


public MensajeConRespuesta deCode(String m ) {
	MensajeConRespuesta resp = new MensajeConRespuesta("ERROR!!", false);
    String res = new String();

    checks[checker].setInput(m);
	try {
		res = checks[checker].deCode().toString();
		resp = new MensajeConRespuesta(res,true);
	}
	catch(ParseException pex) {
		resp = new MensajeConRespuesta(pex.getMessage(),false);
	}
	catch (Throwable other) {
		resp = new MensajeConRespuesta(other.getMessage(),false);
	}
	return resp;
}
	
public boolean hayDeco(){
	return checks[checker].hayDeco();
}


}	
	



