package uniandes.cupi2.messengerAmigos.verificador.mundoAutomata;

import java.util.ArrayList;

public class DivisionN_Base10 extends Automata {
  
  private final int n;
  
  public DivisionN_Base10(int n) {
    this.n=n;
    States myStates=new States();
    for (int i=0; i<n; i++) {
      myStates.storeState(s(i));
    }
    myStates.storeState(s("F"));
    State myStartState=s(0);
    ArrayList<State> myFinalStates=new ArrayList<State>();
    myFinalStates.add(s("F"));
    initializeAutomata(myStates,myStartState,myFinalStates);
  }
  
  protected State delta(State state, char symbol) throws Exception {
    if (symbol=='$'||state.id().equals("F")) {
      return s("F");
    }
    else {
      int q=(Integer)(state.id());
      int c=symbol-'0';
      int r=(q*10+c)%n;
      return s(r);
    }
  }
  
  protected String transitionOutput(State state, char symbol) {
    try {
      if (state.id().equals("F")) {
        return "";
      }
      else if (symbol=='$') {
        return "R"+state.id();
      }
      else {
        int q=(Integer)(state.id());
        int c=symbol-'0';
        int r=(q*10+c)/n;
        return ""+r;
      }
    }
    catch (Throwable th) {
      return "ERROR";
    }
  }
  
  public String toString() {
    return "Dividir por "+n+" en base 10";
  }
  
}
