package uniandes.cupi2.messengerAmigos.verificador.mundoAutomata;

import java.util.ArrayList;

public class DivisionN_BaseB extends Automata {
  
  private final int n;
  private final int base;
  
  public DivisionN_BaseB(int n, int base) {
    if (base<2||base>36) throw new IllegalArgumentException("La base debe estar entre 2 y 36.");
    this.n=n;
    this.base=base;
    States myStates=new States();
    for (int i=0; i<n; i++) {
      myStates.storeState(s(i));
    }
    myStates.storeState(s("F"));
    State myStartState=s(0);
    ArrayList<State> myFinalStates=new ArrayList<State>();
    myFinalStates.add(s("F"));
    initializeAutomata(myStates,myStartState,myFinalStates);
  }
  
  protected State delta(State state, char symbol) throws Exception {
    if (symbol=='$'||state.id().equals("F")) {
      return s("F");
    }
    else {
      int q=(Integer)(state.id());
      int c=Integer.parseInt(String.valueOf(symbol),base);
      int r=(q*base+c)%n;
      return s(r);
    }
  }
  
  protected String transitionOutput(State state, char symbol) {
    try {
      if (state.id().equals("F")) {
        return "";
      }
      else if (symbol=='$') {
        return "R"+state.id();
      }
      else {
        int q=(Integer)(state.id());
        int c=Integer.parseInt(String.valueOf(symbol),base);
        int r=(q*base+c)/n;
        return Integer.toString(r,base).toUpperCase();
      }
    }
    catch (Throwable th) {
      return "ERROR";
    }
  }
  
  public String toString() {
    return "Dividir por "+n+" en base "+base;
  }
  
}
