package uniandes.cupi2.messengerAmigos.verificador.mundoAutomata;

import java.util.ArrayList;

public class FraseAceptable extends Automata{

	final State start = s(0);
	final State sentence = s(1);
	final State question = s(2);
	final State end = s(3);
	final State error = s(4);
	final State inSentence =s(5);
	final State inQuestion =s(6);
	final State exclamation =s(7);
	final State inExclamation = s(8);
	final State startExclamation =s(9);
	final State startQuestion =s(10);
	
	private int shift = 0;
		
	public FraseAceptable()
	{
		super();
	
	
		States myStates = new States() ;
	
		ArrayList <State> myFinalStates = new ArrayList <State> ();
	
		State myStartState;
	
		myStates.storeState(start);
		myStates.storeState(sentence);
		myStates.storeState(question);
		myStates.storeState(end);
		myStates.storeState(error);
		myStates.storeState(exclamation);
		myStates.storeState(inSentence);
		myStates.storeState(inQuestion);
		myStates.storeState(inExclamation);
		myStates.storeState(startQuestion);
		myStates.storeState(startExclamation);
		
		myFinalStates.add(end);
		myStartState = start;
	
		initializeAutomata(myStates,myStartState,myFinalStates);
	}
	
	public FraseAceptable(int shift)
	{
		super();
		this.shift = shift;
	
		States myStates = new States() ;
	
		ArrayList <State> myFinalStates = new ArrayList <State> ();
	
		State myStartState;
	
		myStates.storeState(start);
		myStates.storeState(sentence);
		myStates.storeState(question);
		myStates.storeState(end);
		myStates.storeState(error);
		myStates.storeState(exclamation);
		myStates.storeState(inSentence);
		myStates.storeState(inQuestion);
		myStates.storeState(inExclamation);
		myStates.storeState(startQuestion);
		myStates.storeState(startExclamation);
		
		myFinalStates.add(end);
		myStartState = start;
	
		initializeAutomata(myStates,myStartState,myFinalStates);
	}
	protected   State delta(State s, char c) throws Exception {
		
		State result = error;
		
		if (s == start){
		  if (c == '') 
			  result =  startQuestion;
		  else if (c == '')
			  result =  startExclamation;
		  else
			  if (c >= 'A' && c <= 'Z')
			    result = sentence;
		}		  
		else if (s == sentence)	  
		{
		  if (c >= 'a' && c <= 'z')
			    result = sentence;
		  else if (c == ' ')
			  	result = inSentence;
		  else if ( c == '.')
			  result = end;
		}
		else if (s == question)	  
		{
		  if (c >= 'a' && c <= 'z')
			    result = question;
		  else if (c == ' ')
			  	result = inQuestion;
		  else if ( c == '?')
			  result = end;
		}	
		else if (s == exclamation)	  
		{
			if (c >= 'a' && c <= 'z')
			    result = exclamation;
			else if (c == ' ')
			  	result = inExclamation;
			else if ( c == '!')
			  result = end;
		}	
		else if (s == inSentence)	  
		{
		  if (c >= 'a' && c <= 'z')
			    result = sentence;
		  
		}
		else if (s == inQuestion)	  
		{
		  if (c >= 'a' && c <= 'z')
			    result = question;
		}	
		else if (s == inExclamation)	  
		{
			if (c >= 'a' && c <= 'z')
			    result = exclamation;
		}	
		else if (s == startQuestion)	  
		{
			if (c >= 'A' && c <= 'Z')
				result = question;
		  
		}	
		else if (s == startExclamation)	  
		{
			if (c >= 'A' && c <= 'Z')
			    result = exclamation;
		}	
		else if (s==end) {
			if (c == ' ')
			    result = start;
		}
			
		return result;
	}
	
	protected String transitionOutput(State s, char c){
		
		int  x = (int) c;
		char d = (char)(x+shift);
		if (c <= 'z' && c >= 'a')
			return new String(""+d);
		else 
			return new String(""+c);
	   }
	 	
		public String toString() {
		   return "Frase Aceptable";
	   }
	}
