/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: AyudanteConversacionLocal.java,v 1.1 2006/11/09 03:13:57 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 7/05/2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

package uniandes.cupi2.messengerAmigos.testCliente;

import java.io.IOException;

import uniandes.cupi2.messengerAmigos.cliente.ClienteAmigos;
import uniandes.cupi2.messengerAmigos.cliente.Conversacion;

/**
 * Esta clase sirve para facilitar las pruebas de la clase ClienteAmigos.<br>
 * Esta clase permite crear una conversacin en un thread diferente al principal y hacer que esta espere una conexin.
 */
public class AyudanteConversacionLocal extends Thread
{
    // -----------------------------------------------------------------
    // Atributos
    // -----------------------------------------------------------------

    /**
     * Es el cliente amigos sobre el que se estn realizando las pruebas
     */
    private ClienteAmigos clienteAmigos;

    /**
     * Es la conversacin local que el cliente va a crear
     */
    private Conversacion conversacion;

    // -----------------------------------------------------------------
    // Constructores
    // -----------------------------------------------------------------

    /**
     * Crea el ayudante pero no crea todava la conversacin
     * @param cliente Es el cliente sobre el que se estn haciendo las pruebas
     */
    public AyudanteConversacionLocal( ClienteAmigos cliente )
    {
        clienteAmigos = cliente;
    }

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Crea la conversacin
     */
    public void run( )
    {
        try
        {
            conversacion = clienteAmigos.crearConversacionLocal( "Alicia" );
        }
        catch( IOException e )
        {
            e.printStackTrace( );
        }
    }

    /**
     * Retorna la conversacin creada
     * @return conversacion
     */
    public Conversacion darConversacion( )
    {
        return conversacion;
    }

}
