/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: SimuladorClienteAmigos.java,v 1.1 2006/11/09 03:13:57 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 3/05/2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

package uniandes.cupi2.messengerAmigos.testCliente;

import java.io.IOException;

import uniandes.cupi2.messengerAmigos.cliente.Conversacion;
import uniandes.cupi2.messengerAmigos.cliente.IClienteMessenger;
import uniandes.cupi2.messengerAmigos.cliente.Usuario;

/**
 * Esta clase cumple con la interfaz IClienteMessenger, aunque no implementa todos los mtodos. <br>
 * Su objetivo es ayudar a simplificar las pruebas que se realizan a la clase Conversacin.
 */
public class SimuladorClienteAmigos implements IClienteMessenger
{
    // -----------------------------------------------------------------
    // Atributos
    // -----------------------------------------------------------------

    /**
     * Es el nombre del usuario que se supone est conectado usando el cliente
     */
    private String nombreUsuario;

    // -----------------------------------------------------------------
    // Constructores
    // -----------------------------------------------------------------

    /**
     * Construye el simulador
     * @param nombre El nombre del usuario que se supone utiliza el cliente
     */
    public SimuladorClienteAmigos( String nombre )
    {
        nombreUsuario = nombre;
    }

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Retorna el nombre del usuario
     * @return nombreUsuario
     */
    public String darNombreUsuario( )
    {
        return nombreUsuario;
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @return false
     */
    public boolean estaConectado( )
    {
        return false;
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param usuario
     * @throws IOException Se lanza esta excepcin si hay problemas en la comunicacin
     */
    public void conectar( String usuario ) throws IOException
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     */
    public void enviarDesconexion( )
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @throws IOException Se lanza esta excepcin si hay problemas en la comunicacin
     */
    public void desconectar( ) throws IOException
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param nombreAmigo
     */
    public void agregarAmigo( String nombreAmigo )
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param amigo
     */
    public void actualizarEstado( Usuario amigo )
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param amigo
     * @return null
     * @throws IOException Se lanza esta excepcin si hay problemas en la comunicacin
     */
    public Conversacion crearConversacionLocal( String amigo ) throws IOException
    {
        return null;
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param ipAmigo
     * @param nombreAmigo
     * @param puertoAmigo
     * @throws IOException Se lanza esta excepcin si hay problemas en la comunicacin
     */
    public void conectarAConversacion( String nombreAmigo, String ipAmigo, int puertoAmigo ) throws IOException
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @param conv
     */
    public void eliminarConversacion( Conversacion conv )
    {
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @return null
     */
    public String metodo1( )
    {
        return null;
    }

    /**
     * Este mtodo no est implementado porque no es necesario para las pruebas
     * @return null
     */
    public String metodo2( )
    {
        return null;
    }

}
