/** ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: SimuladorVentanaConversacion.java,v 1.1 2006/11/09 03:13:57 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License versin 2.1
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 3/05/2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

package uniandes.cupi2.messengerAmigos.testCliente;

import uniandes.cupi2.messengerAmigos.interfazCliente.IVentanaConversacion;

/**
 * Esta clase cumple con la interfaz IVentanaConversacion.<br>
 * Su objetivo es ayudar a simplificar las pruebas que se realizan a la clase Conversacin.s
 */
public class SimuladorVentanaConversacion implements IVentanaConversacion
{
    // -----------------------------------------------------------------
    // Atributos
    // -----------------------------------------------------------------

    /**
     * El ltimo mensaje publicado en la ventana
     */
    private String ultimoMensaje;

    /**
     * Indica si la ventana ya fue cerrada
     */
    private boolean cerrada;

    // -----------------------------------------------------------------
    // Constructores
    // -----------------------------------------------------------------

    /**
     * Construye la ventana.
     */
    public SimuladorVentanaConversacion( )
    {
        cerrada = false;
    }

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Se publica un mensaje. Este mtodo, junto con darUltimoMensaje(), se usar para verificar que la conversacin efectivamente haya publicado el mensaje.
     * @param mensaje El mensaje publicado
     */
    public void publicarMensaje( String mensaje )
    {
        ultimoMensaje = mensaje;
    }

    /**
     * Cierra la ventana
     */
    public void dispose( )
    {
        cerrada = true;
    }

    /**
     * Retorna el ltimo mensaje recibido
     * @return ultimoMensaje
     */
    public String darUltimoMensaje( )
    {
        return ultimoMensaje;
    }

    /**
     * Indica si la ventana ya fue cerrada
     * @return cerrada
     */
    public boolean estaCerrada( )
    {
        return cerrada;
    }

	@Override
	public void changeCheck(int i) {
		// TODO Auto-generated method stub
		
	}
}
