/**
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 * $Id: UsuarioTest.java,v 1.1 2006/11/09 03:13:57 f-vela Exp $
 * Universidad de los Andes (Bogot - Colombia)
 * Departamento de Ingeniera de Sistemas y Computacin 
 * Licenciado bajo el esquema Academic Free License version 2.1 
 *
 * Proyecto Cupi2 (http://cupi2.uniandes.edu.co)
 * Ejercicio: n12_messengerAmigos
 * Autor: Mario Snchez - 21-abr-2006
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */
package uniandes.cupi2.messengerAmigos.testCliente;

import junit.framework.TestCase;
import uniandes.cupi2.messengerAmigos.cliente.Usuario;

/**
 * Esta clase se encarga de verificar la correcta implementacin de los mtodos de la clase Usuario
 */
public class UsuarioTest extends TestCase
{
    // -----------------------------------------------------------------
    // Atributos
    // -----------------------------------------------------------------

    /**
     * Es el objeto donde se harn las pruebas
     */
    private Usuario usuario;

    // -----------------------------------------------------------------
    // Mtodos
    // -----------------------------------------------------------------

    /**
     * Construye un nuevo Usuario desconectado para las pruebas
     */
    private void setupEscenario1( )
    {
        usuario = new Usuario( "Pedro" );
    }

    /**
     * Construye un nuevo Usuario desconectado para las pruebas
     */
    private void setupEscenario2( )
    {
        usuario = new Usuario( "Pedro", "127.0.0.1", 9998 );
    }

    /**
     * Verifica el constructor con slo un parmetro
     */
    public void testUsuario1( )
    {
        setupEscenario1( );

        assertEquals( "El estado del usuario es incorrecto", Usuario.OFFLINE, usuario.darEstado( ) );
        assertEquals( "El nombre del usuario es incorrecto", "Pedro", usuario.darNombre( ) );
    }

    /**
     * Verifica el constructor con varios parmetros
     */
    public void testUsuario2( )
    {
        setupEscenario2( );

        assertEquals( "El estado del usuario es incorrecto", Usuario.ONLINE, usuario.darEstado( ) );
        assertEquals( "El nombre del usuario es incorrecto", "Pedro", usuario.darNombre( ) );
        assertEquals( "La direccin IP del usuario es incorrecta", "127.0.0.1", usuario.darDireccionIp( ) );
        assertEquals( "El puerto del usuario es incorrecto", 9998, usuario.darPuerto( ) );
    }

    /**
     * Verifica el mtodo cambiarEstado()
     */
    public void testCambiarEstado1( )
    {
        setupEscenario2( );

        usuario.cambiarEstado( );
        assertEquals( "El estado del usuario es incorrecto", Usuario.OFFLINE, usuario.darEstado( ) );
        assertEquals( "El nombre del usuario es incorrecto", "Pedro", usuario.darNombre( ) );
    }

    /**
     * Verifica el mtodo cambiarEstado(String, int)
     */
    public void testCambiarEstado2( )
    {
        setupEscenario1( );

        usuario.cambiarEstado( "127.0.0.1", 9998 );
        assertEquals( "El estado del usuario es incorrecto", Usuario.ONLINE, usuario.darEstado( ) );
        assertEquals( "El nombre del usuario es incorrecto", "Pedro", usuario.darNombre( ) );
        assertEquals( "La direccin IP del usuario es incorrecta", "127.0.0.1", usuario.darDireccionIp( ) );
        assertEquals( "El puerto del usuario es incorrecto", 9998, usuario.darPuerto( ) );
    }
}