package gold.structures.automaton;

public interface IPushdownDelta<V> {
  
  public V getInput();
  
  public V getOutput();
  
  public String getPrefix();
  
  public IPushdownTransition<V> removeTransition(String pPhi, String pRho);
  
  public IPushdownTransition<V> insertTransition(String pPhi, String pRho);
  
  public IPushdownTransition<V> push(String pRho);
  
  public IPushdownTransition<V> pop(String pPhi);
  
  public IPushdownTransition<V> ignore();
  
  public IPushdownTransition<V> pushOn(String pPhi, String pRho);
  
  public IPushdownTransition<V> skip(String pPhi);
  
  public IPushdownTransition<V> changeTop(String pPhi, String pRho);
  
}
