package gold.structures.bag;

import java.util.*;
import gold.structures.collection.*;
import gold.structures.map.*;
import gold.util.*;

public class GAVLTreeBag<E> extends GAdaptorBag<E> {
  
  private static final long serialVersionUID=6490006031169467266L;
  
  public GAVLTreeBag(Comparator<? super E> pComparator) {
    super(new GAVLTreeMap.AVLTree<E,Integer>(pComparator));
  }
  
  public GAVLTreeBag() {
    this(GComparators.<E>genericComparator());
  }
  
  public GAVLTreeBag(Map<? extends E,Integer> pBag) {
    this();
    toJavaMap().putAll(pBag);
  }
  
  public GAVLTreeBag(IMap<? extends E,Integer> pBag) {
    this(pBag.toJavaView());
  }
  
  public GAVLTreeBag(Collection<? extends E> pCollection) {
    this();
    toJavaView().addAll(pCollection);
  }
  
  public GAVLTreeBag(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
  }
  
}
