package gold.structures.bag;

import java.util.*;
import gold.structures.collection.*;
import gold.structures.map.*;

public class GHashTableBag<E> extends GAdaptorBag<E> {
  
  private static final long serialVersionUID=-9195119063310169241L;
  
  public GHashTableBag() {
    this(128);
  }
  
  public GHashTableBag(int pInitialCapacity) {
    super(new HashMap<E,Integer>(pInitialCapacity));
  }
  
  public GHashTableBag(Map<? extends E,Integer> pBag) {
    super(new HashMap<E,Integer>(pBag));
  }
  
  public GHashTableBag(IMap<? extends E,Integer> pBag) {
    this(pBag.toJavaView());
  }
  
  public GHashTableBag(Collection<? extends E> pCollection) {
    this(pCollection.size()/4);
    toJavaView().addAll(pCollection);
  }
  
  public GHashTableBag(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
  }
  
}
