package gold.structures.bag;

import java.util.*;
import gold.structures.collection.*;
import gold.structures.map.*;

public class GLinkedHashTableBag<E> extends GAdaptorBag<E> {
  
  private static final long serialVersionUID=-269716290748876043L;
  
  public GLinkedHashTableBag() {
    this(128);
  }
  
  public GLinkedHashTableBag(int pInitialCapacity) {
    super(new LinkedHashMap<E,Integer>(pInitialCapacity));
  }
  
  public GLinkedHashTableBag(Map<? extends E,Integer> pBag) {
    super(new LinkedHashMap<E,Integer>(pBag));
  }
  
  public GLinkedHashTableBag(IMap<? extends E,Integer> pBag) {
    this(pBag.toJavaView());
  }
  
  public GLinkedHashTableBag(Collection<? extends E> pCollection) {
    this(pCollection.size()/4);
    toJavaView().addAll(pCollection);
  }
  
  public GLinkedHashTableBag(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
  }
  
}
