package gold.structures.bag;

import java.util.*;
import gold.structures.collection.*;
import gold.structures.map.*;
import gold.util.*;

public class GRedBlackTreeBag<E> extends GAdaptorBag<E> {
  
  private static final long serialVersionUID=-3585276980541512709L;
  
  public GRedBlackTreeBag(Comparator<? super E> pComparator) {
    super(new TreeMap<E,Integer>(pComparator));
  }
  
  public GRedBlackTreeBag() {
    this(GComparators.<E>genericComparator());
  }
  
  public GRedBlackTreeBag(Map<? extends E,Integer> pBag) {
    this();
    toJavaMap().putAll(pBag);
  }
  
  public GRedBlackTreeBag(IMap<? extends E,Integer> pBag) {
    this(pBag.toJavaView());
  }
  
  public GRedBlackTreeBag(Collection<? extends E> pCollection) {
    this();
    toJavaView().addAll(pCollection);
  }
  
  public GRedBlackTreeBag(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
  }
  
}
