package gold.structures.bag;

import java.util.*;
import java.util.concurrent.*;
import gold.structures.collection.*;
import gold.structures.map.*;
import gold.util.*;

public class GSkipListBag<E> extends GAdaptorBag<E> {
  
  private static final long serialVersionUID=-2718774578833439736L;
  
  public GSkipListBag(Comparator<? super E> pComparator) {
    super(new ConcurrentSkipListMap<E,Integer>(pComparator));
  }
  
  public GSkipListBag() {
    this(GComparators.<E>genericComparator());
  }
  
  public GSkipListBag(Map<? extends E,Integer> pBag) {
    this();
    toJavaMap().putAll(pBag);
  }
  
  public GSkipListBag(IMap<? extends E,Integer> pBag) {
    this(pBag.toJavaView());
  }
  
  public GSkipListBag(Collection<? extends E> pCollection) {
    this();
    toJavaView().addAll(pCollection);
  }
  
  public GSkipListBag(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
  }
  
}
