package gold.structures.bag;

import java.util.*;
import gold.structures.collection.*;

public interface IBag<E> extends ICollection<E> {
  
  @Override
  public Collection<E> toJavaView();
  
  public Map<E,Integer> toJavaMap();
  
  @Override
  public IBag<E> clone();
  
  public void add(E pElement);
  
  public void add(E pElement, int pFrequency);
  
  public void remove(E pElement);
  
  public void remove(E pElement, int pFrecuency);
  
  public int count(Object pElement);
  
  public void union(IBag<? extends E> pBag);
  
  public void intersection(IBag<? extends E> pBag);
  
  public void difference(IBag<? extends E> pBag);
  
  public void symmetricDifference(IBag<? extends E> pBag);
  
  public boolean isSubbag(IBag<?> pBag);
  
  public boolean isSuperbag(IBag<?> pBag);
  
  public boolean isProperSubbag(IBag<?> pBag);
  
  public boolean isProperSuperbag(IBag<?> pBag);
  
  public boolean isDisjointFrom(IBag<?> pBag);
  
}
