package gold.structures.collection;

import java.util.*;
import gold.util.*;

public class GAdaptorCollection<E> extends GAbstractCollection<E> {
  
  private static final long serialVersionUID=-7838896446775869949L;
  
  protected final Collection<E> adaptee;
  
  public GAdaptorCollection(Collection<E> pAdaptee) {
    adaptee=pAdaptee;
  }
  
  @Override
  public int size() {
    return adaptee.size();
  }
  
  @Override
  public void clear() {
    adaptee.clear();
  }
  
  @Override
  public Iterator<E> iterator() {
    return adaptee.iterator();
  }
  
  @Override
  public Collection<E> toJavaView() {
    return adaptee;
  }
  
  @Override
  @SuppressWarnings("unchecked")
  public ICollection<E> clone() {
    try {
      return new GAdaptorCollection<E>((Collection<E>)(GToolkit.clone(adaptee)));
    }
    catch (Throwable th) {
      throw new InternalError("The class "+adaptee.getClass().getCanonicalName()+" is not cloneable.");
    }
  }
  
}
