package gold.structures.collection;

import java.io.*;
import java.util.*;

public interface ICollection<E> extends Iterable<E>,Cloneable,Serializable {
  
  public int size();
  
  public boolean isEmpty();
  
  public boolean isFinite();
  
  public void clear();
  
  public E pick();
  
  @Override
  public Iterator<E> iterator();
  
  public boolean contains(Object pElement);
  
  @Override
  public boolean equals(Object pObject);
  
  @Override
  public int hashCode();
  
  @Override
  public String toString();
  
  public Object[] toArray();
  
  public <T> T[] toArray(T[] pArray);
  
  public Collection<E> toJavaView();
  
  public ICollection<E> clone();
  
}
