package gold.structures.deque;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GAdaptorDeque<E> extends GAbstractCollection<E> implements IDeque<E> {
  
  private static final long serialVersionUID=-1244968345552833140L;
  
  protected final Deque<E> adaptee;
  
  public GAdaptorDeque(Deque<E> pAdaptee) {
    adaptee=pAdaptee;
  }
  
  @Override
  public int size() {
    return adaptee.size();
  }
  
  @Override
  public void clear() {
    adaptee.clear();
  }
  
  @Override
  public Iterator<E> iterator() {
    return adaptee.iterator();
  }
  
  @Override
  public Deque<E> toJavaView() {
    return adaptee;
  }
  
  @Override
  @SuppressWarnings("unchecked")
  public IDeque<E> clone() {
    try {
      return new GAdaptorDeque<E>((Deque<E>)(GToolkit.clone(adaptee)));
    }
    catch (Throwable th) {
      throw new InternalError("The class "+adaptee.getClass().getCanonicalName()+" is not cloneable.");
    }
  }
  
  @Override
  public E getFirst() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.getFirst();
  }
  
  @Override
  public E getLast() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.getLast();
  }
  
  @Override
  public void addFirst(E pElement) {
    adaptee.addFirst(pElement);
  }
  
  @Override
  public void addLast(E pElement) {
    adaptee.addLast(pElement);
  }
  
  @Override
  public E removeFirst() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.removeFirst();
  }
  
  @Override
  public E removeLast() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.removeLast();
  }
  
}
