package gold.structures.disjointset;

import gold.structures.list.*;

public class GListDisjointSet<E> implements IDisjointSet<E> {
  
  private static final long serialVersionUID=-320908689523737104L;
  
  protected E data;
  protected IList<GListDisjointSet<E>> neighbors;
  
  public GListDisjointSet(E pData) {
    data=pData;
    neighbors=new GArrayList<GListDisjointSet<E>>(4);
    neighbors.addLast(this);
  }
  
  @Override
  public E getData() {
    return data;
  }
  
  protected IList<GListDisjointSet<E>> getNeighbors() {
    return neighbors;
  }
  
  @Override
  public void setData(E pData) {
    data=pData;
  }
  
  protected void setNeighbors(IList<GListDisjointSet<E>> pNeighbors) {
    neighbors=pNeighbors;
  }
  
}
