package gold.structures.graph;

import edu.uci.ics.jung.graph.*;

@IIsUndirected
public class GUndirectedGraph<V,E> extends GDirectedGraph<V,E> {
  
  private static final long serialVersionUID=-2168826677139688430L;
  
  public GUndirectedGraph(Iterable<? extends V> pVertices) {
    super(pVertices);
  }
  
  public GUndirectedGraph(Iterable<? extends V> pVertices, Iterable<?> pEdges) {
    super(pVertices,pEdges);
  }
  
  public GUndirectedGraph(IGraph<? extends V,? extends E> pGraph) {
    super(pGraph);
  }
  
  public GUndirectedGraph(Graph<? extends V,? extends E> pGraph) {
    super(pGraph);
  }
  
  @Override
  public void addEdge(V pSource, V pTarget, double pCost, E pData) {
    super.addEdge(pSource,pTarget,pCost,pData);
    super.addEdge(pTarget,pSource,pCost,pData);
  }
  
  @Override
  public void removeEdge(V pSource, V pTarget) {
    super.removeEdge(pSource,pTarget);
    super.removeEdge(pTarget,pSource);
  }
  
  @Override
  public GUndirectedGraph<V,E> clone() {
    return new GUndirectedGraph<V,E>(this);
  }
  
}
