package gold.structures.graph;

import java.io.*;
import java.util.*;

public interface IEdge<V,E> extends Comparable<IEdge<V,E>>,Iterable<Object>,Cloneable,Serializable {
  
  public static final double INFINITE_COST=Double.POSITIVE_INFINITY;
  
  public V getSource();
  
  public V getTarget();
  
  public double getCost();
  
  public E getData();
  
  @Override
  public Iterator<Object> iterator();
  
  @Override
  public int compareTo(IEdge<V,E> pEdge);
  
  @Override
  public boolean equals(Object pObject);
  
  @Override
  public int hashCode();
  
  @Override
  public String toString();
  
  public IEdge<V,E> clone();
  
}
