package gold.structures.list;

import java.util.*;
import gold.structures.tuple.*;

public interface IList<E> extends ITuple<E> {
  
  @Override
  public List<E> toJavaView();
  
  @Override
  public IList<E> clone();
  
  public E getFirst();
  
  public E getLast();
  
  @Override
  public E get(int pIndex);
  
  public void addFirst(E pElement);
  
  public void addLast(E pElement);
  
  public void add(int pIndex, E pElement);
  
  public void add(E pElement);
  
  public E removeFirst();
  
  public E removeLast();
  
  public E remove(int pIndex);
  
  public void setFirst(E pElement);
  
  public void setLast(E pElement);
  
  @Override
  public void set(int pIndex, E pElement);
  
  public int count(Object pElement);
  
  public int firstIndexOf(E pElement);
  
  public int lastIndexOf(E pElement);
  
  public void concatenate(IList<? extends E> pList);
  
  public void reverse();
  
  public IList<E> sublist(int pStartIndex, int pEndIndex);
  
}
