package gold.structures.map;

import java.util.*;
import gold.util.*;

public class GRedBlackTreeMap<K,V> extends GAdaptorMap<K,V> {
  
  private static final long serialVersionUID=-2961993886612693083L;
  
  public GRedBlackTreeMap(Comparator<? super K> pComparator) {
    super(new TreeMap<K,V>(pComparator));
  }
  
  public GRedBlackTreeMap() {
    this(GComparators.<K>genericComparator());
  }
  
  public GRedBlackTreeMap(Map<? extends K,? extends V> pMap) {
    this();
    toJavaView().putAll(pMap);
  }
  
  public GRedBlackTreeMap(IMap<? extends K,? extends V> pMap) {
    this(pMap.toJavaView());
  }
  
}
