package gold.structures.map;

import java.util.*;
import java.util.concurrent.*;
import gold.util.*;

public class GSkipListMap<K,V> extends GAdaptorMap<K,V> {
  
  private static final long serialVersionUID=52539424996681328L;
  
  public GSkipListMap(Comparator<? super K> pComparator) {
    super(new ConcurrentSkipListMap<K,V>(pComparator));
  }
  
  public GSkipListMap() {
    this(GComparators.<K>genericComparator());
  }
  
  public GSkipListMap(Map<? extends K,? extends V> pMap) {
    this();
    toJavaView().putAll(pMap);
  }
  
  public GSkipListMap(IMap<? extends K,? extends V> pMap) {
    this(pMap.toJavaView());
  }
  
}
