package gold.structures.map;

import java.io.*;
import java.util.*;
import gold.structures.collection.*;
import gold.structures.set.*;

public interface IMap<K,V> extends Iterable<V>,Cloneable,Serializable {
  
  public int size();
  
  public boolean isEmpty();
  
  public void clear();
  
  @Override
  public Iterator<V> iterator();
  
  public ISet<K> keys();
  
  public ICollection<V> values();
  
  public boolean containsKey(Object pKey);
  
  public boolean containsValue(V pValue);
  
  public V get(Object pKey);
  
  public void put(K pKey, V pValue);
  
  public V remove(Object pKey);
  
  @Override
  public boolean equals(Object pObject);
  
  @Override
  public int hashCode();
  
  @Override
  public String toString();
  
  public Map<K,V> toJavaView();
  
  public IMap<K,V> clone();
  
}
