package gold.structures.multimap;

import java.util.*;
import gold.structures.map.*;
import gold.structures.set.*;
import gold.util.*;

public class GAdaptorMultiMap<K,V> extends GAdaptorMap<K,ISet<V>> implements IMultiMap<K,V> {
  
  private static final long serialVersionUID=-7017300886086187855L;
  
  public GAdaptorMultiMap(Map<K,ISet<V>> pAdaptee) {
    super(pAdaptee);
  }
  
  @Override
  public ISet<V> get(Object pKey) {
    ISet<V> collection=super.get(pKey);
    return collection!=null?collection:GCollections.<V>emptySet();
  }
  
  @Override
  public void put(K pKey, ISet<V> pValues) {
    super.put(pKey,new GHashTableSet<V>(pValues));
  }
  
  @Override
  public void add(K pKey, V pValue) {
    ISet<V> collection=super.get(pKey);
    if (collection==null) super.put(pKey,collection=new GHashTableSet<V>(4));
    collection.toJavaView().add(pValue);
  }
  
  @Override
  public V remove(Object pKey, V pValue) {
    ISet<V> collection=super.get(pKey);
    if (collection!=null) {
      boolean result=collection.toJavaView().remove(pValue);
      if (collection.isEmpty()) super.remove(pKey);
      return result?pValue:null;
    }
    return null;
  }
  
  @Override
  @SuppressWarnings("unchecked")
  public IMultiMap<K,V> clone() {
    try {
      return new GAdaptorMultiMap<K,V>((Map<K,ISet<V>>)(GToolkit.clone(adaptee)));
    }
    catch (Throwable th) {
      throw new InternalError("The class "+adaptee.getClass().getCanonicalName()+" is not cloneable.");
    }
  }
  
}
