package gold.structures.multimap;

import java.util.*;
import gold.structures.map.*;
import gold.structures.set.*;

public class GHashTableMultiMap<K,V> extends GAdaptorMultiMap<K,V> {
  
  private static final long serialVersionUID=-5727953995300552636L;
  
  public GHashTableMultiMap() {
    this(256);
  }
  
  public GHashTableMultiMap(int pInitialCapacity) {
    super(new HashMap<K,ISet<V>>(pInitialCapacity));
  }
  
  public GHashTableMultiMap(Map<? extends K,? extends ISet<V>> pMultiMap) {
    this(pMultiMap.size());
    for (Map.Entry<? extends K,? extends ISet<V>> entry:pMultiMap.entrySet()) {
      put(entry.getKey(),entry.getValue());
    }
  }
  
  public GHashTableMultiMap(IMap<? extends K,? extends ISet<V>> pMultiMap) {
    this(pMultiMap.toJavaView());
  }
  
}
