package gold.structures.multimap;

import java.util.*;
import gold.structures.map.*;
import gold.structures.set.*;
import gold.util.*;

public class GRedBlackTreeMultiMap<K,V> extends GAdaptorMultiMap<K,V> {
  
  private static final long serialVersionUID=-5511378782067838902L;
  
  public GRedBlackTreeMultiMap(Comparator<? super K> pComparator) {
    super(new TreeMap<K,ISet<V>>(pComparator));
  }
  
  public GRedBlackTreeMultiMap() {
    this(GComparators.<K>genericComparator());
  }
  
  public GRedBlackTreeMultiMap(Map<? extends K,? extends ISet<V>> pMultiMap) {
    this();
    for (Map.Entry<? extends K,? extends ISet<V>> entry:pMultiMap.entrySet()) {
      put(entry.getKey(),entry.getValue());
    }
  }
  
  public GRedBlackTreeMultiMap(IMap<? extends K,? extends ISet<V>> pMultiMap) {
    this(pMultiMap.toJavaView());
  }
  
}
