package gold.structures.multimap;

import java.util.*;
import java.util.concurrent.*;
import gold.structures.map.*;
import gold.structures.set.*;
import gold.util.*;

public class GSkipListMultiMap<K,V> extends GAdaptorMultiMap<K,V> {
  
  private static final long serialVersionUID=-200297273063047155L;
  
  public GSkipListMultiMap(Comparator<? super K> pComparator) {
    super(new ConcurrentSkipListMap<K,ISet<V>>(pComparator));
  }
  
  public GSkipListMultiMap() {
    this(GComparators.<K>genericComparator());
  }
  
  public GSkipListMultiMap(Map<? extends K,? extends ISet<V>> pMultiMap) {
    this();
    for (Map.Entry<? extends K,? extends ISet<V>> entry:pMultiMap.entrySet()) {
      put(entry.getKey(),entry.getValue());
    }
  }
  
  public GSkipListMultiMap(IMap<? extends K,? extends ISet<V>> pMultiMap) {
    this(pMultiMap.toJavaView());
  }
  
}
