package gold.structures.point;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;

import gold.structures.collection.*;

public class GLatticePoint extends Point implements ILatticePoint {
  
  private static final long serialVersionUID=-3830985446843367242L;
  
  public GLatticePoint(int pCoordinateX, int pCoordinateY) {
    super(pCoordinateX,pCoordinateY);
  }
  
  public GLatticePoint(Point pPoint) {
    super(pPoint);
  }
  
  public GLatticePoint(int[] pCoordinates) {
    super(pCoordinates[0],pCoordinates[1]);
  }
  
  public GLatticePoint(Iterable<?> pCoordinates) {
    Iterator<?> it=pCoordinates.iterator();
    setLocation(((Number)(it.next())).intValue(),((Number)(it.next())).intValue());
  }
  
  @Override
  public int getCoordinateX() {
    return super.x;
  }
  
  @Override
  public int getCoordinateY() {
    return super.y;
  }
  
  @Override
  public void getCoordinateX(int pCoordinateX) {
    super.x=pCoordinateX;
  }
  
  @Override
  public void getCoordinateY(int pCoordinateY) {
    super.y=pCoordinateY;
  }
  
  @Override
  public Iterator<Integer> iterator() {
    return new GAbstractIterator<Integer>() {
      private int index=0;
      @Override
      public boolean hasNext() {
        return index<2;
      }
      @Override
      public Integer next() {
        return index++==0?getCoordinateX():getCoordinateY();
      }
    };
  }
  
  @Override
  public Point2D toJavaView() {
    return this;
  }
  
  @Override
  public ILatticePoint clone() {
    return new GLatticePoint(super.x,super.y);
  }
  
}
