package gold.structures.point;

import java.awt.geom.*;
import java.util.*;

import gold.structures.collection.*;

public class GPoint extends Point2D.Double implements IPoint {
  
  private static final long serialVersionUID=-816602974421141594L;
  
  public GPoint(double pCoordinateX, double pCoordinateY) {
    super(pCoordinateX,pCoordinateY);
  }
  
  public GPoint(Point2D pPoint) {
    super(pPoint.getX(),pPoint.getY());
  }
  
  public GPoint(double[] pCoordinates) {
    super(pCoordinates[0],pCoordinates[1]);
  }
  
  public GPoint(Iterable<?> pCoordinates) {
    Iterator<?> it=pCoordinates.iterator();
    setLocation(((Number)(it.next())).doubleValue(),((Number)(it.next())).doubleValue());
  }
  
  @Override
  public double getCoordinateX() {
    return super.x;
  }
  
  @Override
  public double getCoordinateY() {
    return super.y;
  }
  
  @Override
  public void getCoordinateX(double pCoordinateX) {
    super.x=pCoordinateX;
  }
  
  @Override
  public void getCoordinateY(double pCoordinateY) {
    super.y=pCoordinateY;
  }
  
  @Override
  public Iterator<java.lang.Double> iterator() {
    return new GAbstractIterator<java.lang.Double>() {
      private int index=0;
      @Override
      public boolean hasNext() {
        return index<2;
      }
      @Override
      public java.lang.Double next() {
        return index++==0?getCoordinateX():getCoordinateY();
      }
    };
  }
  
  @Override
  public Point2D toJavaView() {
    return this;
  }
  
  @Override
  public IPoint clone() {
    return new GPoint(super.x,super.y);
  }
  
}
