package gold.structures.queue;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GAdaptorQueue<E> extends GAbstractCollection<E> implements IQueue<E> {
  
  private static final long serialVersionUID=7411663235201178984L;
  
  protected final Queue<E> adaptee;
  
  public GAdaptorQueue(Queue<E> pAdaptee) {
    adaptee=pAdaptee;
  }
  
  @Override
  public int size() {
    return adaptee.size();
  }
  
  @Override
  public void clear() {
    adaptee.clear();
  }
  
  @Override
  public Iterator<E> iterator() {
    return adaptee.iterator();
  }
  
  @Override
  public Queue<E> toJavaView() {
    return adaptee;
  }
  
  @Override
  @SuppressWarnings("unchecked")
  public IQueue<E> clone() {
    try {
      return new GAdaptorQueue<E>((Queue<E>)(GToolkit.clone(adaptee)));
    }
    catch (Throwable th) {
      throw new InternalError("The class "+adaptee.getClass().getCanonicalName()+" is not cloneable.");
    }
  }
  
  @Override
  public E head() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.element();
  }
  
  @Override
  public void enqueue(E pElement) {
    adaptee.add(pElement);
  }
  
  @Override
  public E dequeue() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.remove();
  }
  
}
