package gold.structures.set;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GRedBlackTreeSet<E> extends GAdaptorSet<E> {
  
  private static final long serialVersionUID=2445308942195003281L;
  
  public GRedBlackTreeSet(Comparator<? super E> pComparator) {
    super(new TreeSet<E>(pComparator));
  }
  
  public GRedBlackTreeSet() {
    this(GComparators.<E>genericComparator());
  }
  
  public GRedBlackTreeSet(Collection<? extends E> pCollection) {
    this();
    toJavaView().addAll(pCollection);
  }
  
  public GRedBlackTreeSet(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
    if (!pCollection.isFinite()) complement();
  }
  
}
