package gold.structures.set;

import java.util.*;
import java.util.concurrent.*;
import gold.structures.collection.*;
import gold.util.*;

public class GSkipListSet<E> extends GAdaptorSet<E> {
  
  private static final long serialVersionUID=-4651953465110771510L;
  
  public GSkipListSet(Comparator<? super E> pComparator) {
    super(new ConcurrentSkipListSet<E>(pComparator));
  }
  
  public GSkipListSet() {
    this(GComparators.<E>genericComparator());
  }
  
  public GSkipListSet(Collection<? extends E> pCollection) {
    this();
    toJavaView().addAll(pCollection);
  }
  
  public GSkipListSet(ICollection<? extends E> pCollection) {
    this(pCollection.toJavaView());
    if (!pCollection.isFinite()) complement();
  }
  
}
