package gold.structures.set;

import java.util.*;
import gold.structures.automaton.*;
import gold.structures.collection.*;
import gold.structures.tree.nary.*;

public class GTrieStringSet extends GAdaptorSet<String> {
  
  private static final long serialVersionUID=747532141297009276L;
  
  protected GTrieStringSet(GTrie pTrie) {
    super(pTrie.toJavaView());
  }
  
  public GTrieStringSet(IAlphabet pAlphabet) {
    this(new GTrie(pAlphabet));
  }
  
  public GTrieStringSet(IAlphabet pAlphabet, Collection<String> pCollection) {
    this(new GTrie(pAlphabet,pCollection));
  }
  
  public GTrieStringSet(IAlphabet pAlphabet, ICollection<String> pCollection) {
    this(new GTrie(pAlphabet,pCollection));
    if (!pCollection.isFinite()) complement();
  }
  
}
