package gold.structures.set;

import java.util.*;
import gold.structures.collection.*;

public interface ISet<E> extends ICollection<E> {
  
  @Override
  public Set<E> toJavaView();
  
  @Override
  public ISet<E> clone();
  
  public void add(E pElement);
  
  public void remove(E pElement);
  
  public void union(ISet<? extends E> pSet);
  
  public void intersection(ISet<? extends E> pSet);
  
  public void difference(ISet<? extends E> pSet);
  
  public void symmetricDifference(ISet<? extends E> pSet);
  
  public void complement();
  
  public boolean isSubset(ISet<?> pSet);
  
  public boolean isSuperset(ISet<?> pSet);
  
  public boolean isProperSubset(ISet<?> pSet);
  
  public boolean isProperSuperset(ISet<?> pSet);
  
  public boolean isDisjointFrom(ISet<?> pSet);
  
  @Override
  public boolean isFinite();
  
  public boolean isCofinite();
  
  public boolean isUniverse();
  
}
