package gold.structures.stack;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GAdaptorStack<E> extends GAbstractCollection<E> implements IStack<E> {
  
  private static final long serialVersionUID=-2309645636497570456L;
  
  protected final List<E> adaptee;
  
  public GAdaptorStack(List<E> pAdaptee) {
    adaptee=pAdaptee;
  }
  
  @Override
  public int size() {
    return adaptee.size();
  }
  
  @Override
  public void clear() {
    adaptee.clear();
  }
  
  @Override
  public Iterator<E> iterator() {
    return adaptee.iterator();
  }
  
  @Override
  public List<E> toJavaView() {
    return adaptee;
  }
  
  @Override
  @SuppressWarnings("unchecked")
  public IStack<E> clone() {
    try {
      return new GAdaptorStack<E>((List<E>)(GToolkit.clone(adaptee)));
    }
    catch (Throwable th) {
      throw new InternalError("The class "+adaptee.getClass().getCanonicalName()+" is not cloneable.");
    }
  }
  
  @Override
  public E peek() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.get(size()-1);
  }
  
  @Override
  public void push(E pElement) {
    adaptee.add(pElement);
  }
  
  @Override
  public E pop() {
    if (isEmpty()) throw new NoSuchElementException();
    return adaptee.remove(size()-1);
  }
  
}
