package gold.structures.tree;

import gold.structures.collection.*;
import gold.structures.list.*;
import gold.structures.tuple.*;
import edu.uci.ics.jung.graph.*;

public interface ITree<E> extends ICollection<E> {
  
  @Override
  public ITree<E> clone();
  
  public E getRoot();
  
  public IList<? extends ITree<E>> getSubtrees();
  
  public ITree<E> getSubtree(int pIndex);
  
  public IList<E> getChildren();
  
  public boolean isLeaf();
  
  public int getOrder();
  
  public int getWeight();
  
  public int getHeight();
  
  public int count(E pElement);
  
  public IList<E> preOrderTraversal();
  
  public IList<E> inOrderTraversal();
  
  public IList<E> postOrderTraversal();
  
  public IList<E> levelOrderTraversal();
  
  public Tree<ITree<E>,IPair<ITree<E>>> toJungCopy();
  
}
