package gold.structures.tree.binary;

import gold.structures.list.*;
import gold.structures.tree.*;
import gold.structures.tuple.*;
import edu.uci.ics.jung.graph.*;

public interface IBinaryTree<E> extends ITree<E> {
  
  @Override
  public IBinaryTree<E> clone();
  
  @Override
  public E getRoot();
  
  public IBinaryTree<E> getLeftSubtree();
  
  public IBinaryTree<E> getRightSubtree();
  
  public void setRoot(E pRoot);
  
  public void setLeftSubtree(IBinaryTree<E> pLeftSubtree);
  
  public void setRightSubtree(IBinaryTree<E> pRightSubtree);
  
  @Override
  public IList<IBinaryTree<E>> getSubtrees();
  
  @Override
  public IBinaryTree<E> getSubtree(int pIndex);
  
  @Override
  public IList<E> getChildren();
  
  @Override
  public boolean isLeaf();
  
  @Override
  public int getOrder();
  
  @Override
  public int getWeight();
  
  @Override
  public int getHeight();
  
  @Override
  public int count(E pElement);
  
  @Override
  public IList<E> preOrderTraversal();
  
  @Override
  public IList<E> inOrderTraversal();
  
  @Override
  public IList<E> postOrderTraversal();
  
  @Override
  public IList<E> levelOrderTraversal();
  
  @Override
  public Tree<ITree<E>,IPair<ITree<E>>> toJungCopy();
  
}
