package gold.structures.tree.nary;

import java.awt.*;

public enum GQuadtreeColor {
  
  BLACK('B'),WHITE('W'),GRAY('G');
  
  private final char identifier;
  
  private GQuadtreeColor(char pIdentifier) {
    identifier=pIdentifier;
  }
  
  public char getIdentifier() {
    return identifier;
  }
  
  public Color getColor() {
    return isGray()?Color.GRAY:(isBlack()?Color.BLACK:Color.WHITE);
  }
  
  public boolean isBlack() {
    return this==GQuadtreeColor.BLACK;
  }
  
  public boolean isWhite() {
    return this==GQuadtreeColor.WHITE;
  }
  
  public boolean isGray() {
    return this==GQuadtreeColor.GRAY;
  }
  
  @Override
  public String toString() {
    return String.valueOf(identifier);
  }
  
  public static GQuadtreeColor getColor(char pIdentifier) {
    for (GQuadtreeColor color:GQuadtreeColor.values()) {
      if (color.getIdentifier()==pIdentifier) return color;
    }
    return GQuadtreeColor.GRAY;
  }
  
}
