package gold.structures.tree.nary;

import gold.structures.list.*;
import gold.structures.tree.*;
import gold.structures.tuple.*;
import edu.uci.ics.jung.graph.*;

public interface INaryTree<E> extends ITree<E> {
  
  @Override
  public INaryTree<E> clone();
  
  @Override
  public E getRoot();
  
  @Override
  public IList<INaryTree<E>> getSubtrees();
  
  public void setRoot(E pRoot);
  
  public void setSubtrees(IList<INaryTree<E>> pSubtrees);
  
  public void addSubtree(INaryTree<E> pSubtree);
  
  public void addSubtree(int pIndex, INaryTree<E> pSubtree);
  
  public void removeSubtree(int pIndex);
  
  @Override
  public INaryTree<E> getSubtree(int pIndex);
  
  @Override
  public IList<E> getChildren();
  
  @Override
  public boolean isLeaf();
  
  @Override
  public int getOrder();
  
  @Override
  public int getWeight();
  
  @Override
  public int getHeight();
  
  @Override
  public int count(E pElement);
  
  @Override
  public IList<E> preOrderTraversal();
  
  @Override
  public IList<E> inOrderTraversal();
  
  @Override
  public IList<E> postOrderTraversal();
  
  @Override
  public IList<E> levelOrderTraversal();
  
  @Override
  public Tree<ITree<E>,IPair<ITree<E>>> toJungCopy();
  
}
