package gold.structures.tuple;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GPair<E> extends GAbstractCollection<E> implements IPair<E> {
  
  private static final long serialVersionUID=1559534468842261201L;
  
  protected E first=null;
  protected E second=null;
  
  public GPair(E pFirst, E pSecond) {
    first=pFirst;
    second=pSecond;
  }
  
  @Override
  public E get(int pIndex) {
    if (pIndex==0) {
      return first;
    }
    else if (pIndex==1) {
      return second;
    }
    else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  @Override
  public void set(int pIndex, E pElement) {
    if (pIndex==0) {
      first=pElement;
    }
    else if (pIndex==1) {
      second=pElement;
    }
    else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  @Override
  public E getFirst() {
    return first;
  }
  
  @Override
  public E getSecond() {
    return second;
  }
  
  @Override
  public void setFirst(E pFirst) {
    first=pFirst;
  }
  
  @Override
  public void setSecond(E pSecond) {
    second=pSecond;
  }
  
  @Override
  public int size() {
    return 2;
  }
  
  @Override
  public void clear() {
    throw new UnsupportedOperationException();
  }
  
  @Override
  public boolean equals(Object pObject) {
    if (pObject instanceof IPair) {
      return GToolkit.equals(first,((IPair<?>)pObject).getFirst())&&GToolkit.equals(second,((IPair<?>)pObject).getSecond());
    }
    else if (pObject instanceof ICouple) {
      return GToolkit.equals(first,((ICouple<?,?>)pObject).getFirst())&&GToolkit.equals(second,((ICouple<?,?>)pObject).getSecond());
    }
    else if (pObject instanceof ITuple) {
      ITuple<?> tuple=(ITuple<?>)pObject;
      return tuple.size()==2&&GToolkit.equals(first,tuple.get(0))&&GToolkit.equals(second,tuple.get(1));
    }
    else {
      return super.equals(pObject);
    }
  }
  
  @Override
  public List<E> toJavaView() {
    return new AbstractList<E>() {
      @Override
      public E get(int pIndex) {
        return GPair.this.get(pIndex);
      }
      @Override
      public E set(int pIndex, E pElement) {
        E oldElement=GPair.this.get(pIndex);
        GPair.this.set(pIndex,pElement);
        return oldElement;
      }
      @Override
      public int size() {
        return GPair.this.size();
      }
    };
  }
  
  @Override
  public GPair<E> clone() {
    return new GPair<E>(first,second);
  }
  
}
