package gold.structures.tuple;

import java.util.*;
import gold.structures.collection.*;
import gold.util.*;

public class GSingleton<E> extends GAbstractCollection<E> implements ISingleton<E> {
  
  private static final long serialVersionUID=4966379129242708298L;
  
  protected E element=null;
  
  public GSingleton(E pElement) {
    element=pElement;
  }
  
  @Override
  public E get(int pIndex) {
    if (pIndex==0) {
      return element;
    }
    else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  @Override
  public void set(int pIndex, E pElement) {
    if (pIndex==0) {
      element=pElement;
    }
    else {
      throw new IndexOutOfBoundsException();
    }
  }
  
  @Override
  public E getElement() {
    return element;
  }
  
  @Override
  public void setElement(E pElement) {
    element=pElement;
  }
  
  @Override
  public int size() {
    return 1;
  }
  
  @Override
  public void clear() {
    throw new UnsupportedOperationException();
  }
  
  @Override
  public boolean equals(Object pObject) {
    if (pObject instanceof ISingleton) {
      return GToolkit.equals(element,((ISingleton<?>)pObject).getElement());
    }
    else if (pObject instanceof ITuple) {
      ITuple<?> tuple=(ITuple<?>)pObject;
      return tuple.size()==1&&GToolkit.equals(element,tuple.get(0));
    }
    else {
      return super.equals(pObject);
    }
  }
  
  @Override
  public List<E> toJavaView() {
    return new AbstractList<E>() {
      @Override
      public E get(int pIndex) {
        return GSingleton.this.get(pIndex);
      }
      @Override
      public E set(int pIndex, E pElement) {
        E oldElement=GSingleton.this.get(pIndex);
        GSingleton.this.set(pIndex,pElement);
        return oldElement;
      }
      @Override
      public int size() {
        return GSingleton.this.size();
      }
    };
  }
  
  @Override
  public GSingleton<E> clone() {
    return new GSingleton<E>(element);
  }
  
}
