package gold.structures.tuple;

import java.util.*;
import gold.structures.collection.*;
import gold.structures.list.*;

public class GTuple<E> extends GAbstractCollection<E> implements ITuple<E> {
  
  private static final long serialVersionUID=6136160611485119780L;
  
  protected final List<E> adaptee;
  
  public GTuple(E...pElements) {
    adaptee=Arrays.asList(pElements);
  }
  
  public GTuple(List<E> pElements) {
    adaptee=pElements;
  }
  
  public GTuple(IList<E> pElements) {
    adaptee=pElements.toJavaView();
  }
  
  @Override
  public E get(int pIndex) {
    return adaptee.get(pIndex);
  }
  
  @Override
  public void set(int pIndex, E pElement) {
    adaptee.set(pIndex,pElement);
  }
  
  @Override
  public int size() {
    return adaptee.size();
  }
  
  @Override
  public void clear() {
    throw new UnsupportedOperationException();
  }
  
  @Override
  public List<E> toJavaView() {
    return adaptee;
  }
  
  @Override
  public GTuple<E> clone() {
    return new GTuple<E>(new ArrayList<E>(adaptee));
  }
  
}
