package gold.swing.look;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import gold.swing.util.*;

public class GCheckBoxMenuItemLook extends BasicCheckBoxMenuItemUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GCheckBoxMenuItemLook();
  }
  
  @Override
  protected void paintBackground(Graphics pGraphics, JMenuItem pMenuItem, Color pColor) {
    GMenuItemLook.paintBackground(pGraphics,pMenuItem);
  }
  
  @Override
  protected Dimension getPreferredMenuItemSize(JComponent pComponent, Icon pCheckIcon, Icon pArrowIcon, int pDefaultTextIconGap) {
    return super.getPreferredMenuItemSize(pComponent,pCheckIcon,pArrowIcon,GMenuItemLook.getTextIconGap(pComponent,pCheckIcon,pDefaultTextIconGap));
  }
  
  @Override
  protected void paintText(Graphics pGraphics, JMenuItem pMenuItem, Rectangle pTextRect, String pText) {
    super.paintText(pGraphics,pMenuItem,GMenuItemLook.getTextRectangle(pGraphics,pMenuItem,pTextRect),pText);
  }
  
  @Override
  protected void paintMenuItem(Graphics pGraphics, JComponent pComponent, Icon pCheckIcon, Icon pArrowIcon, Color pBackground, Color pForeground, int pDefaultTextIconGap) {
    JMenuItem menuItem=(JMenuItem)pComponent;
    int textHeight=pGraphics.getFontMetrics().getHeight();
    GMenuItemLook.paint(pGraphics,pComponent,GUtilities.getIcon("gold/checkButton"+(menuItem.isSelected()?1:2)+".png"),pCheckIcon,pArrowIcon,pBackground,pForeground,pDefaultTextIconGap);
    paintText(pGraphics,menuItem,new Rectangle(30,(menuItem.getHeight()-textHeight)/2,menuItem.getWidth()-30,textHeight),menuItem.getText());
  }
  
}
