package gold.swing.look;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import javax.swing.plaf.metal.*;
import gold.swing.util.*;

public class GComboBoxLook extends MetalComboBoxUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GComboBoxLook();
  }
  
  @Override
  public void installUI(JComponent pComponent) {
    ((JComboBox)pComponent).setEditable(false);
    GLookAndFeel.configureBorder(pComponent);
    GLookAndFeel.configureSize(pComponent);
    super.installUI(pComponent);
  }
  
  @Override
  protected ComboPopup createPopup() {
    BasicComboPopup popup=(BasicComboPopup)(super.createPopup());
    popup.setBorder(BorderFactory.createLineBorder(GColor.BORDER));
    return popup;
  }
  
  @Override
  protected JButton createArrowButton() {
    JButton button=new JButton(GUtilities.getIcon("gold/comboArrow.png"));
    button.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
    button.setBackground(new Color(0,0,0,0));
    button.setBorder(BorderFactory.createEmptyBorder());
    button.setFocusPainted(false);
    button.setContentAreaFilled(false);
    return button;
  }
  
  @Override
  public void paint(Graphics pGraphics, JComponent pComponent) {
    int left=4;
    GLookAndFeel.paintBackground(pComponent,pGraphics);
    JComboBox comboBox=(JComboBox)pComponent;
    Component component=comboBox.getRenderer().getListCellRendererComponent(super.listBox,comboBox.getSelectedItem(),-1,false,false);
    component.setEnabled(pComponent.isEnabled());
    super.currentValuePane.paintComponent(pGraphics,component,comboBox,left,0,comboBox.getWidth()-left,comboBox.getHeight(),(component instanceof JPanel));
  }
  
}
