package gold.swing.look;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;

public class GMenuBarLook extends MetalMenuBarUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GMenuBarLook();
  }
  
  @Override
  public void installUI(JComponent pComponent) {
    super.installUI(pComponent);
    pComponent.setPreferredSize(new Dimension(pComponent.getPreferredSize().width,22));
    pComponent.setOpaque(true);
    pComponent.setBackground(new Color(0,0,0,0));
    pComponent.setBorder(BorderFactory.createEmptyBorder(1,0,0,0));
  }
  
  @Override
  public void paint(Graphics pGraphics, JComponent pComponent) {
    int w=pComponent.getWidth(),h=pComponent.getHeight();
    Graphics2D graphics=(Graphics2D)pGraphics;
    graphics.setPaint(new GradientPaint(0,0,new Color(255,255,255),0,h,new Color(200,200,200)));
    graphics.fillRect(0,0,w,h);
    super.paint(pGraphics,pComponent);
  }
  
}
