package gold.swing.look;

import java.awt.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.basic.*;
import gold.swing.util.*;

public class GMenuLook extends BasicMenuUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GMenuLook();
  }
  
  @Override
  protected void paintBackground(Graphics pGraphics, JMenuItem pMenuItem, Color pColor) {
    GMenuItemLook.paintBackground(pGraphics,pMenuItem);
  }
  
  @Override
  protected Dimension getPreferredMenuItemSize(JComponent pComponent, Icon pCheckIcon, Icon pArrowIcon, int pDefaultTextIconGap) {
    return super.getPreferredMenuItemSize(pComponent,pCheckIcon,pArrowIcon,GMenuItemLook.getTextIconGap(pComponent,pCheckIcon,pDefaultTextIconGap));
  }
  
  @Override
  protected void paintText(Graphics pGraphics, JMenuItem pMenuItem, Rectangle pTextRect, String pText) {
    super.paintText(pGraphics,pMenuItem,GMenuItemLook.getTextRectangle(pGraphics,pMenuItem,pTextRect),pText);
  }
  
  @Override
  protected void paintMenuItem(Graphics pGraphics, JComponent pComponent, Icon pCheckIcon, Icon pArrowIcon, Color pBackground, Color pForeground, int pDefaultTextIconGap) {
    JMenuItem menuItem=(JMenuItem)pComponent;
    if (menuItem.getParent() instanceof JMenuBar) {
      super.paintMenuItem(pGraphics,pComponent,pCheckIcon,pArrowIcon,pBackground,pForeground,pDefaultTextIconGap);
    }
    else {
      Graphics2D graphics=(Graphics2D)pGraphics;
      graphics.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
      Icon icon=menuItem.isEnabled()?menuItem.getIcon():menuItem.getDisabledIcon();
      int textHeight=graphics.getFontMetrics().getHeight();
      paintBackground(graphics,menuItem,menuItem.getBackground());
      if (icon!=null) icon.paintIcon(menuItem,graphics,6,(menuItem.getHeight()-icon.getIconHeight())/2);
      paintText(graphics,menuItem,new Rectangle(30,(menuItem.getHeight()-textHeight)/2,menuItem.getWidth()-30,textHeight),menuItem.getText());
      Icon arrowIcon=GUtilities.getIcon("gold/scrollArrow2.png");
      arrowIcon=menuItem.isEnabled()?arrowIcon:UIManager.getLookAndFeel().getDisabledIcon(menuItem,arrowIcon);
      arrowIcon.paintIcon(menuItem,graphics,menuItem.getWidth()-arrowIcon.getIconWidth()-5,(menuItem.getHeight()-arrowIcon.getIconHeight())/2);
    }
  }
  
}
