package gold.swing.look;

import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;
import gold.swing.util.*;

public class GRadioButtonLook extends MetalRadioButtonUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GRadioButtonLook((AbstractButton)pComponent);
  }
  
  private final AbstractButton button;
  
  private GRadioButtonLook(AbstractButton pButton) {
    button=pButton;
  }
  
  @Override
  public Icon getDefaultIcon() {
    Icon icon=GUtilities.getIcon("gold/radioButton"+(button.isSelected()?1:2)+".png");
    return button.isEnabled()?icon:UIManager.getLookAndFeel().getDisabledIcon(button,icon);
  }
  
}
