package gold.swing.look;

import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import javax.swing.plaf.*;
import javax.swing.plaf.metal.*;
import gold.swing.util.*;

public class GTabbedPaneLook extends MetalTabbedPaneUI {
  
  public static ComponentUI createUI(JComponent pComponent) {
    return new GTabbedPaneLook(true);
  }
  
  private final boolean withBorderContent;
  
  public GTabbedPaneLook(boolean pWithBorderContent) {
    withBorderContent=pWithBorderContent;
  }
  
  @Override
  protected Insets getContentBorderInsets(int pTabPlacement) {
    int b=withBorderContent?1:0;
    return new Insets(1,b,b,b);
  }
  
  @Override
  protected void paintTabBackground(Graphics pGraphics, int pTabPlacement, int pTabIndex, int pX, int pY, int pW, int pH, boolean pIsSelected) {
    int radius=pH*12/10;
    Graphics2D graphics=GUtilities.setRenderingHints(pGraphics);
    Shape clip=graphics.getClip(),rect=new Rectangle(pX,pY,pW,pH),roundRect=new RoundRectangle2D.Double(pX-radius,pY,pW+radius-2,pH+radius,radius,radius);
    graphics.setPaint(GColor.BACKGROUND);
    graphics.fill(rect);
    graphics.clip(rect);
    graphics.setPaint(new GradientPaint(pX,pY,pIsSelected?new Color(244,227,181):new Color(200,200,200),pX,pY+pH,pIsSelected?new Color(218,165,32):new Color(100,100,100)));
    graphics.fill(roundRect);
    graphics.setPaint(Color.GRAY);
    graphics.draw(roundRect);
    graphics.setClip(clip);
  }
  
  @Override
  protected void paintTabBorder(Graphics pGraphics, int pTabPlacement, int pTabIndex, int pX, int pY, int pW, int pH, boolean pIsSelected) {
    pGraphics.setColor(GColor.BACKGROUND);
    pGraphics.drawLine(pX+pW-1,pY,pX+pW-1,pY+pH);
  }
  
}
