package gold.swing.util;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

@SuppressWarnings("serial")
public final class GAboutDialog extends JDialog {
  
  public GAboutDialog(Component pOwner) {
    super(GUtilities.getWindowForComponent(pOwner),"About GOLD",JDialog.ModalityType.TOOLKIT_MODAL);
    JLabel iconLabel=new JLabel(GUtilities.getIcon("wikimedia/GoldEagle.png"));
    iconLabel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(),BorderFactory.createEmptyBorder(0,8,0,8)));
    iconLabel.setBackground(new Color(205,205,205));
    iconLabel.setOpaque(true);
    JEditorPane aboutLabel=new GEditorPane("<center><b><h2>GOLD "+getMajorVersion()+"<br/>Graph Oriented Language Domain</h2></b>Version ID: "+getMinorVersion()+" ["+getLastDate()+"]<br/>Operative System: "+GUtilities.escapeHTML(GUtilities.OPERATIVE_SYSTEM)+"<br/><br/>Copyright \u00A9 2011 Universidad de los Andes.<br/>All rights reserved.<br/><br/><table border='0'><tr><td>2011</td><td> GOLD v3.0</td><td>: Alejandro Sotelo Arévalo</td></tr><tr><td>2010</td><td> GOLD v2.0</td><td>: Diana Mabel Díaz Herrera</td></tr><tr><td>2009</td><td> GOLD v1.0</td><td>: Luis Miguel Pérez Díez</td></tr></table><br/>Homepage <a href='http://wwwest.uniandes.edu.co/~a-sotelo/GOLD3/'>http://wwwest.uniandes.edu.co/~a-sotelo/GOLD3/</a><br/><br/><br/></center>",false);
    aboutLabel.setBorder(BorderFactory.createEmptyBorder(0,10,0,0));
    aboutLabel.addHyperlinkListener(new HyperlinkListener() {
      @Override
      public void hyperlinkUpdate(HyperlinkEvent pEvent) {
        try {
          if (pEvent.getEventType()==HyperlinkEvent.EventType.ACTIVATED&&Desktop.isDesktopSupported()) Desktop.getDesktop().browse(pEvent.getURL().toURI());
        }
        catch (Throwable th) {
        }
      }
    });
    JButton closeButton=new JButton("Close");
    closeButton.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent pEvent) {
        dispose();
      }
    });
    GUtilities.configure(this,GUtilities.getBorderPane(5,5,0,8,null,iconLabel,aboutLabel,null,GUtilities.getFlowPane(FlowLayout.RIGHT,closeButton)));
  }
  
  public static String getMajorVersion() {
    return "v3.0";
  }
  
  public static String getMinorVersion() {
    return "v3.0.8";
  }
  
  public static String getLastDate() {
    return "27/06/2012 (dd/mm/yyyy)";
  }
  
}
