package gold.swing.util;

import java.util.*;
import javax.swing.*;

@SuppressWarnings("serial")
public final class GButtonGroup extends ButtonGroup {
  
  public GButtonGroup(AbstractButton...pButtons) {
    for (AbstractButton button:pButtons) {
      add(button);
    }
  }
  
  public String getSelectedActionCommand(AbstractButton pDefault) {
    ButtonModel buttonModel=super.getSelection();
    String actionCommand=buttonModel==null?null:buttonModel.getActionCommand();
    return actionCommand!=null?actionCommand:pDefault.getActionCommand();
  }
  
  public void setSelectedActionCommand(String pActionCommand, AbstractButton pDefaultButton) {
    for (AbstractButton button:Collections.list(super.getElements())) {
      String actionCommand=button.getActionCommand();
      if (actionCommand!=null&&actionCommand.equals(pActionCommand)) {
        button.setSelected(true);
        return;
      }
    }
    pDefaultButton.setSelected(true);
  }
  
}
