package gold.swing.util;

import java.awt.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;

@SuppressWarnings("serial")
public final class GEditorPane extends JEditorPane {
  
  public GEditorPane(String pText, boolean pEditable) {
    super("text/html",pText);
    setEditable(pEditable);
    if (!pEditable) {
      setBorder(BorderFactory.createEmptyBorder());
      setBackground((Color)(UIManager.get("Label.background")));
      setForeground((Color)(UIManager.get("Label.foreground")));
    }
    setFont(getFont());
    setCaretPosition(0);
  }
  
  @Override
  public void setFont(Font pFont) {
    Document document=getDocument();
    if (document!=null) ((HTMLDocument)document).getStyleSheet().addRule("body{font-family:"+pFont.getFamily()+";font-size:"+pFont.getSize()+"pt;}");
    super.setFont(pFont);
  }
  
}
