package gold.swing.util;

import java.awt.*;
import java.awt.event.*;
import java.util.concurrent.*;
import javax.swing.*;

@SuppressWarnings("serial")
public final class GWaitDialog extends JDialog {
  
  private GWaitDialog(Component pOwner) {
    super(GUtilities.getWindowForComponent(pOwner),"",JDialog.ModalityType.TOOLKIT_MODAL);
    getRootPane().setWindowDecorationStyle(JRootPane.NONE);
    setResizable(false);
    setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
    JPanel panelUp=GUtilities.getFlowPane(FlowLayout.CENTER,new JLabel(GUtilities.getIcon("ajaxload/ajax-loader.gif")));
    JPanel panelCenter=GUtilities.getFlowPane(FlowLayout.LEFT,new JLabel("<html><center>Operation in progress.<p>Wait a moment please.</center></html>"));
    JPanel panel=GUtilities.getBorderPane(panelUp,null,panelCenter,null,null);
    panel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createLineBorder(GColor.BORDER,2),BorderFactory.createEmptyBorder(8,8,8,8)));
    panel.setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
    setContentPane(panel);
    pack();
  }
  
  public static void wait(Component pOwner, final Callable<Void> pCallable) throws Throwable {
    final GWaitDialog dialog=new GWaitDialog(pOwner);
    final Throwable throwableArray[]={null};
    dialog.addWindowListener(new WindowAdapter() {
      @Override
      public void windowOpened(WindowEvent pEvent) {
        new Thread() {
          @Override
          public void run() {
            try {
              pCallable.call();
            }
            catch (Throwable th) {
              throwableArray[0]=th;
            }
            dialog.dispose();
          }
        }.start();
      }
    });
    GUtilities.center(dialog);
    dialog.setVisible(true);
    if (throwableArray[0]!=null) throw throwableArray[0];
  }
  
}
