package gold.test.automaton;

import gold.structures.automaton.*;
import gold.structures.set.*;
import gold.swing.util.*;
import gold.util.*;
import gold.visualization.automaton.*;

import static gold.util.GCollections.*;

public class TestDFT {
  
  private static final int n=4;
  public static void main(String[] args) {
    GUtilities.installGoldLookAndFeel();
    // Dividir por n en base 10
    // Q={x|0<=x<n}U{F}
    // Σ={'0','1','2',...,'9','$'}
    // Σ'={'0','1','2',...,'9','R'}
    // qI=0
    // F={F}
    // δ(q,s)=if s='$' or q=F then F else (q*10+s)%n fi
    // h(q,s)=if q=F then λ elseif s='$' then "R"+q else (q*10+s)/n fi
    ISet<?> states=union(integerInterval(0,n-1),singletonSet("F"));
    IAlphabet inputAlphabet=new GAlphabet("0123456789$");
    IAlphabet outputAlphabet=new GAlphabet("0123456789R");
    Object initialState=0;
    ISet<?> acceptStates=singletonSet("F");
    IMethod delta=new GMethod(TestDFT.class,"delta");
    IMethod g=new GMethod(TestDFT.class,"g");
    IMethod h=new GMethod(TestDFT.class,"h");
    GDeterministicTransducer<Object> automaton=new GDeterministicTransducer<Object>(states,inputAlphabet,outputAlphabet,initialState,acceptStates,delta,g,h);
    GAutomataFrame frame=new GAutomataFrame();
    frame.display(automaton);
    frame.setVisible(true);
    System.out.println(automaton.acceptsString("652518546153$"));
    System.out.println(automaton.getOutputString());
  }
  
  public static Object delta(String q, char s) {
    return "F";
  }
  
  public static Object delta(int q, char s) {
    return s=='$'?"F":(q*10+s-'0')%n;
  }
  
  public static String g(Object q) {
    return "";
  }
  
  public static String h(String q, char s) {
    return "";
  }
  
  public static String h(int q, char s) {
    return s=='$'?"R"+q:""+((q*10+s-'0')/n);
  }
  
}
