package gold.test.automaton;

import gold.structures.automaton.*;
import gold.structures.set.*;
import gold.swing.util.*;
import gold.util.*;
import gold.visualization.automaton.*;

public class TestPDA {
  
  public static void main(String[] args) {
    GUtilities.installGoldLookAndFeel();
    ISet<?> states=GCollections.asSet('A','B');
    IAlphabet inputAlphabet=new GAlphabet("ab");
    IAlphabet stackAlphabet=new GAlphabet("a");
    Object initialState='A';
    ISet<?> acceptStates=GCollections.asSet('B');
    GPushdownAutomaton<Object> automaton=new GPushdownAutomaton<Object>(states,inputAlphabet,stackAlphabet,initialState,acceptStates);
    automaton.delta('A','A',"a").push("a");
    automaton.delta('A','B',"").ignore();
    automaton.delta('B','B',"b").pop("a");
    System.out.println(automaton.acceptsString("aaabbb"));
    System.out.println(automaton.acceptsString("aaabbbb"));
    System.out.println(automaton.acceptsString("aaaabbb"));
    GAutomataFrame frame=new GAutomataFrame();
    frame.display(automaton);
    frame.setVisible(true);
  }
  
}
