package gold.test.automaton;

import gold.structures.automaton.*;
import gold.structures.set.*;
import gold.structures.tuple.*;
import gold.swing.util.*;
import gold.util.*;
import gold.visualization.automaton.*;
import static gold.util.GCollections.*;

@SuppressWarnings("unchecked")
public class TestTAK2011 {
  
  public static void main(String[] args) {
    GUtilities.installGoldLookAndFeel();
    // Q={<x,y>|0<=x,y<5}U{err}
    // Σ={'0','1','2','a'}
    // qI=<0,0>
    // F={<x,x>|0<=x<4}
    // δ(<x,y>,s)=if s='a' then (if y<4 then <x,y+1> else err fi) else ((x+1)%5,y) fi
    // δ(err,s)=err
    ISet<?> states=union(cartesianPower(asSet(0,1,2,3,4),2),singletonSet("err"));
    IAlphabet alphabet=new GAlphabet("012a");
    Object initialState=new GPair<Integer>(0,0);
    ISet<?> acceptStates=asSet(new GPair<Integer>(0,0),new GPair<Integer>(1,1),new GPair<Integer>(2,2),new GPair<Integer>(3,3),new GPair<Integer>(4,4));
    IMethod delta=new GMethod(TestTAK2011.class,"delta");
    GDeterministicAutomaton<Object> automaton=new GDeterministicAutomaton<Object>(states,alphabet,initialState,acceptStates,delta);
    GAutomataFrame frame=new GAutomataFrame();
    frame.setVisible(true);
    frame.display("[TAK2011] #00",automaton);
  }
  
  public static Object delta(String pInput, char pAction) {
    return "err";
  }
  
  public static Object delta(ITuple<Integer> pInput, char pAction) {
    int x=pInput.get(0),y=pInput.get(1);
    return pAction=='a'?(y<4?new GPair<Integer>(x,y+1):"err"):new GPair<Integer>((x+1)%5,y);
  }
  
}
