package gold.test.general;

import java.awt.event.*;
import javax.swing.*;
import javax.swing.UIManager.*;
import gold.util.*;
import gold.visualization.automaton.*;

public class TestLookAndFeel {
  
  public static void main(String[] args) {
    final GAutomataFrame frame=new GAutomataFrame();
    frame.setSize(new java.awt.Dimension(350,220));
    frame.setVisible(true);
    GAutomatonInternalFrame internalFrame=frame.display("Accepts strings containing abaa",GAutomata.parse("ab","0","4","0-a-1,0-b-0,1-a-1,1-b-2,2-a-3,2-b-0,3-a-4,3-b-2,4-a-4,4-b-4"));
    frame.getDesktop().maximizeInternalFrame(internalFrame);
    for (LookAndFeelInfo info:UIManager.getInstalledLookAndFeels()) {
      System.out.println(info.getName());
      System.out.println("  "+info.getClassName());
    }
    internalFrame.getPainter().getVisualizationViewer().addKeyListener(new KeyAdapter() {
      @Override
      public void keyPressed(KeyEvent e) {
        try {
          switch (Character.toLowerCase(e.getKeyChar())) {
            case 'w':
              UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
              break;
            case 'q':
              UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsClassicLookAndFeel");
              break;
            case 'j':
              UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
              break;
            case 'm':
              UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
              break;
            case 'g':
              UIManager.setLookAndFeel("gold.swing.look.GLookAndFeel");
              break;
            case 'n':
              UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
              break;
            case 'z':
              UIManager.setLookAndFeel("javax.swing.plaf.mac.MacLookAndFeel");
              //UIManager.setLookAndFeel("ch.randelshofer.quaqua.QuaquaLookAndFeel");
              break;
          }
          SwingUtilities.updateComponentTreeUI(frame);
          frame.repaint();
          System.out.println(UIManager.getLookAndFeel().getName());
        }
        catch (Throwable th) {
        }
      }
    });
  }
  
}
