package gold.visualization.util;

import gold.structures.collection.*;
import gold.util.*;
import org.apache.commons.collections15.*;

public class GFilterTransformer<K,V> implements Transformer<K,V> {
  
  protected ICollection<K> filter=null;
  protected V firstValue=null;
  protected V secondValue=null;
  
  public GFilterTransformer(Iterable<? extends K> pFilter, V pFirstValue, V pSecondValue) {
    setFilter(pFilter);
    setFirstValue(pFirstValue);
    setSecondValue(pSecondValue);
  }
  
  public ICollection<K> getFilter() {
    return filter;
  }
  
  public V getFirstValue() {
    return firstValue;
  }
  
  public V getSecondValue() {
    return secondValue;
  }
  
  public void setFilter(Iterable<? extends K> pFilter) {
    filter=GCollections.unmodifiableCollection(pFilter);
  }
  
  public void setFirstValue(V pFirstValue) {
    firstValue=pFirstValue;
  }
  
  public void setSecondValue(V pSecondValue) {
    secondValue=pSecondValue;
  }
  
  @Override
  public V transform(K pKey) {
    return filter==null||filter.contains(pKey)?firstValue:secondValue;
  }
  
}
