package gold.visualization.util;

import edu.uci.ics.jung.graph.*;
import edu.uci.ics.jung.graph.util.*;

import org.apache.commons.collections15.*;

public final class GGraphContextTransformer<V,E,T> implements Transformer<Context<Graph<V,E>,E>,T> {
  
  private final ITransformer<E,T> delegate;
  
  public GGraphContextTransformer(T pDefaultValue) {
    this(new GGeneralTransformer<E,T>(pDefaultValue));
  }
  
  public GGraphContextTransformer(ITransformer<E,T> pDelegate) {
    delegate=pDelegate;
  }
  
  public ITransformer<E,T> getDelegate() {
    return delegate;
  }
  
  @Override
  public T transform(Context<Graph<V,E>,E> pKey) {
    // Context.getInstance(graph,edge)
    return delegate.transform(pKey.element);
  }
  
}
