package gold.visualization.util;

import java.awt.geom.*;
import gold.structures.map.*;
import gold.structures.tuple.*;

public final class GLayoutConfiguration {
  
  private final IMap<String,Point2D> vertexLayout;
  private final IMap<IPair<String>,Point2D[]> edgeLayout;
  
  public GLayoutConfiguration() {
    this(new GHashTableMap<String,Point2D>(32),new GHashTableMap<IPair<String>,Point2D[]>(4));
  }
  
  public GLayoutConfiguration(IMap<String,Point2D> pVertexLayout, IMap<IPair<String>,Point2D[]> pEdgeLayout) {
    vertexLayout=pVertexLayout;
    edgeLayout=pEdgeLayout;
  }
  
  public IMap<String,Point2D> getVertexLayout() {
    return vertexLayout;
  }
  
  public IMap<IPair<String>,Point2D[]> getEdgeLayout() {
    return edgeLayout;
  }
  
  public boolean isEmpty() {
    return vertexLayout.isEmpty()&&edgeLayout.isEmpty();
  }
  
}
