package gold.visualization.util;

import org.apache.commons.collections15.*;

public interface ITransformer<K,V> extends Transformer<K,V> {
  
  public V getDefaultValue();
  
  public V get(K pKey);
  
  public void setDefaultValue(V pDefaultValue);
  
  public void set(K pKey, V pValue);
  
  public void setAll(V pValue);
  
  public void setAll(Iterable<? extends K> pKeys, V pValue);
  
  public void clear(K pKey);
  
  public void clearAll();
  
  public void clearAll(Iterable<? extends K> pKeys);
  
  @Override
  public V transform(K pKey);
  
}
